const express = require('express');
const router = express.Router();
const loadDataByUrl = require('../custom_modules/loadDataByUrl');
const arrToDb = require('../custom_modules/arrToDb');
const  coinModel = require('../model/coinsModel');
/* GET home page. */

router.get('/installDB', function (req, res, next) {
    loadDataByUrl.loadData('https://api.coincap.io/v2/assets').then(data1 => {
         arrToDb.loadArrToDB(data1.data).then(data2 =>{
            res.send(data2);
            console.log('FINISH')
         });
    })
});

router.get('/', (req,res) => {
coinModel.find({}, (err,data) =>{
    if(err){
        console.log(err)
    }
    else{
        res.send(data);
    }
})
})

router.post('/' ,(req,res,next) => {
    var obj = new coinModel({
        id: req.body.id ,
        rank :req.body.rank ,
        symbol :req.body.symbol ,
        name :  req.body.name ,
        supply : req.body.supply,
        maxSupply : req.body.maxSupply,
        marketCapUsd : req.body.marketCapUsd ,
        volumeUsd24Hr :  req.body.volumeUsd24Hr,
        priceUsd :req.body.priceUsd,
        changePercent24Hr :req.body.changePercent24Hr ,
        vwap24Hr :  req.body.vwap24Hr 
    })
    obj.save().then(()=> console.log('POST TO DB'));
    next();
})


router.put('/', (req,res) =>{
    var query = {id: req.body.id};
    coinModel.findOneAndUpdate(query, {$set:{id:req.body.newid}}, (err,doc) =>{
        err? console.log(err) : res.send(doc);
     })

})


router.delete('/',(req,res) =>{
    coinModel.findOneAndDelete({id:req.body.id}, (err) =>{
        err? console.log('err') : console.log('delete')
    } )
})
module.exports = router;
